#include "Graphics.h"
#include <math.h>

Graphics g;

/*
  Simple basic graphics example
  Nicolaas E. Groeneboom, FYS4150 H06
  leuat@irio.co.uk
  http://www.irio.co.uk
*/


int main(int arg, char *args[])
{
  // Opens a window
  g.openWindow("Yay!",600,400); // Parameters are width and height
  // This variable maintains events like keypresses and mouse
  SDL_Event event;
  
  double v = 0; // Wave speed
  double dt = 0.005; // Deltat
  double A = 30; // Amplitude 
  
  bool quit = false;
  while(!quit) // run while quit is false
    {
      // Cleans the screen: 0=black, 255 = white
      g.Clear(0);
      
      // Draws the solution :pixel by pixel
      for (int i=0;i<600;i++) {
          // Calculate x-value scaled...
          double x = (i/40.0);
          int y = (int)(A*(sin(x + v) + cos(x-v*4))); // "almost" standing waves : f(x) = A sin(x+v) + Acos(x-4v)
          g.pixel(i,200-y, 255,255,255); //white colour: red, green and blue are set to max   
      }      
      // Present to the screen
      g.flip();
      
      // Let v = v + dt
       v+=dt;
      
       // Check if any key is pressed
      while ( SDL_PollEvent(&event) ) {
	        switch (event.type) {
                  case SDL_KEYDOWN:
		    quit=true; // Guess what!
	  
            }   
      }
    }

  return 0;
}
